/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.05.03.02 [06 Nov 2018]
* Device(s)    : R5F104GJ
* Tool-Chain   : GCCRL78
* Description  : This file implements main function.
* Creation Date: 
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
const long Array1[2048] = {1, 1, 0, 0, 0, 0, 0};    // 配列定数（1行でROM領域8Kバイト）
const long Array2[2048] = {1, 1, 2, 0, 0, 0, 0};
const long Array3[2048] = {1, 1, 0, 2, 0, 0, 0};
const __far long Array4[2048] = {1, 1, 0, 0, 5, 0, 0};
const __far long Array5[2048] = {1, 1, 0, 0, 0, 10, 0};

long data[2048] = {1, 2, 3, 4};

char c;
unsigned short i;
long lwk1, lwk2, lwk3, lwk4, lwk5;

char SwtchTest(char ac);

__attribute__ ((noinline)) void large_func(void);
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
  {
#if 1
    lwk1 = 0; lwk2 = 0; lwk3 = 0; lwk4 = 0; lwk5 = 0;

    for(i = 0; i<2048; i++){
        lwk1 += data[i] + Array1[i];
        lwk2 += Array2[i];
        lwk3 += Array3[i];
        lwk4 += Array4[i];    // 行をコメント化するとROM定数エリアが8Kバイト減る
        lwk5 += Array5[i];    // <--------- ※１． Array5[0] にとんでもない大きな数値が代入される
    }

    lwk1 = lwk1 + lwk2 +lwk3 + lwk4 + lwk5;
#endif

    large_func();

    while (1U)
    {
        // test switch case
        c = 1;
        c = SwtchTest(c);     // <--------- ※２． swich文に入ったとたんに暴走してプログラムカウンタが 0 になる（０番地へジャンプする）
    }    
  }
    /* End user code. Do not edit comment generated here */
}


/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
char SwtchTest(char ac)
{
    char ret;

    switch(ac)
    {
        case 0:
            ret = ac +1;
            break;
        case 1:
            ret = ac +2;
            break;
        case 2:
            ret = ac +3;
            break;
        case 3:
            ret = ac +4;
            break;
        case 4:
            ret = ac +5;
            break;
        default:
            return -1;
    }
    return ret;
}

void large_func(void)
{
    //__asm volatile (".rept 0xA000"); /* the const startd address exceeds the mirror area */
    //__asm volatile (".rept 0x2000"); /* the const end address exceeds the mirror area */
    __asm volatile (".rept 0");
    __asm volatile ("nop");
    __asm volatile (".endr");
}
/* End user code. Do not edit comment generated here */
